Unit VESA;
Interface
         uses Dos;

         const
              vseg: word = $a000;

         type
             TVESABIOSINFO = record
                           vbSign: longint;
                           vbVersion: word;
                           vbOEMNameOfs: word;
                           vbOEMNameSeg: word;
                           vbCapabilities: longint;
                           vbModeListOfs: word;
                           vbModeListSeg: word;
                           vbTotalMemory: word;
                           vbReserved: array[1..236] of byte;
             end;
             TVESAMODEINFO = record
                           vmModeAttr: word;
                           vmWinAAttr: byte;
                           vmWinBAttr: byte;
                           vmWinGran: word;
                           vmWinSize: word;
                           vmWinAStartSeg: word;
                           vmWinBStartSeg: word;
                           vmPageFuncOfs: word;
                           vmPageFuncSeg: word;
                           vmBytesPerLine: word;
                           vmWidth: word;
                           vmHeight: word;
                           vmCharWidth: byte;
                           vmCharHeight: byte;
                           vmPlanes: byte;
                           vmBitsPerPixel: byte;
                           vmBanks: byte;
                           vmMemModelType: byte;
                           vmBankSize: byte;
{                          vmReservedPage: byte;}
                           vmRedMaskSize: byte;
                           vmRedFieldPos: byte;
                           vmGreenMaskSize: byte;
                           vmGreenFieldPos: byte;
                           vmBlueMaskSize: byte;
                           vmBlueFieldPos: byte;
                           vmRsvdMaskSize: byte;
                           vmRsvdFieldPos: byte;
                           vmDirectColMode: byte;
                           vmReserved: array[1..216] of byte;
             end;

         var
            vb: TVESABIOSINFO;
            vm: TVESAMODEINFO absolute vb;
            ActivePage: word;

         function GetVesaBiosInfo(var vb): boolean;
         function GetVesaModeInfo(m: word; var vm): boolean;
         function SetVesaMode(m: word): boolean;
         function SetVesaPage(p: word): boolean;

         function SetGraphMode(m: word): boolean;
         procedure SetActivePage(p: byte);
         procedure PutPixel256(x, y: integer; c: byte);
         procedure PutPixel32k(x, y: integer; c: word);
         procedure PutPixel16M(x, y: integer; r,g,b: byte);

Implementation
              function GetVesaBiosInfo(var vb): boolean;
              var
                 r: registers;
              begin
                   r.es := Seg(vb);
                   r.di := Ofs(vb);
                   r.ax := $4f00;
                   intr($10,r);
                   GetVesaBiosInfo := r.ax = $004f;
              end;
              function GetVesaModeInfo(m: word; var vm): boolean;
              var
                 r: registers;
              begin
                   r.es := Seg(vm);
                   r.di := Ofs(vm);
                   r.cx := m;
                   r.ax := $4f01;
                   intr($10,r);
                   GetVesaModeInfo := r.ax = $004f;
              end;
              function SetVesaMode(m: word): boolean;
              var
                 r: registers;
              begin
                   r.bx := m;
                   r.ax := $4f02;
                   intr($10,r);
                   SetVesaMode := r.ax = $004f;
              end;
              function SetVesaPage(p: word): boolean;
              var
                 r: registers;
              begin
                   r.dx := p;
                   r.bx := 0;
                   r.ax := $4f05;
                   intr($10,r);
                   SetVesaPage := r.ax = $004f;
              end;

              function SetGraphMode(m: word): boolean;
              var
                 r: registers;
              begin
                   ActivePage := 0;
                   if m and $ff7f < $14 then
                   begin
                        vm.vmBytesPerLine := 320;
                        vm.vmWidth := 320;
                        vm.vmHeight := 200;
                        r.ax := m;
                        intr($10,r);
                        SetGraphMode := Mem[0:$449] = m and $7f;
                   end else
                   begin
                        SetGraphMode := GetVesaModeInfo(m,vm) and SetVesaMode(m);
                   end;
              end;
              procedure SetActivePage(p: byte);
              begin
                   if ActivePage <> p then
                   begin
                        SetVesaPage(p * round(vm.vmWinSize / vm.vmWinGran));
                        ActivePage := p;
                   end;
              end;
              procedure PutPixel256(x, y: integer; c: byte);
              var
                 p,o: word;
                 l: longint absolute o;
              begin
                   l := (y * vm.vmBytesPerLine) + x;
                   SetActivePage(p);
                   Mem[vseg:o] := c;
              end;
              procedure PutPixel32k(x, y: integer; c: word);
              var
                 p,o: word;
                 l: longint absolute o;
              begin
                   l := (y * vm.vmBytesPerLine) + x + x;
                   SetActivePage(p);
                   Memw[vseg:o] := c;
              end;
              procedure PutPixel16M(x, y: integer; r,g,b: byte);
              var
                 p,o: word;
                 l: longint absolute o;
              begin
                   l := (y * vm.vmBytesPerLine) + x + x + x;
                   if vm.vmBitsPerPixel = 32 then
                      l := l + x;
                   SetActivePage(p);
                   Mem[vseg:o] := b;
                   inc(l);
                   if p > ActivePage then
                      SetActivePage(p);
                   Mem[vseg:o] := g;
                   inc(l);
                   if p > ActivePage then
                      SetActivePage(p);
                   Mem[vseg:o] := r;
              end;
end.
