Unit FastFile;
Interface
         const
              BufSize = 8192;
              BufLength = BufSize div 128;
              BufPtr: word = BufSize;
         var
            FileVar: file;
            FilePtr: longint;
            Buffer: array[0..BufSize-1] of byte;
         function ByteRead: byte;
         procedure ByteSeek(n:longint);
         function FastOpen(str:string): boolean;
         procedure FastClose;
         procedure FastLoad(s,o,n:word);
Implementation
              function ByteRead: byte;
              var
                 res:word;
              begin
                   if BufPtr = BufSize then
                        begin
                             BufPtr := 0;
                             BlockRead(FileVar,Buffer,BufLength,res);
                             inc(FilePtr);
                   end;
                   ByteRead := Buffer[BufPtr];
                   inc(BufPtr);
              end;
              procedure ByteSeek(n:longint);
              var
                 res:word;
              begin
                   BufPtr := n mod BufSize;
                   n := n div BufSize;
                   if FilePtr <> n+1 then
                   begin
                        Seek(FileVar,n*BufLength);
                        BlockRead(FileVar,Buffer,BufLength,res);
                        FilePtr := n + 1;
                   end;
              end;
              function FastOpen(str:string): boolean;
              begin
                   assign(FileVar,str);
                   {$I-} reset(FileVar); {$I+}
                   FilePtr := 0;
                   FastOpen := ioresult = 0;
              end;
              procedure FastClose;
              begin
                   close(FileVar);
              end;
              procedure FastLoad(s,o,n:word);
              var
                 i:word;
              begin
                   for i := 0 to n-1 do Mem[s:o+i] := ByteRead;
              end;
end.